sbit LCD_RS at RB5_bit;               //Configurazione LCD
sbit LCD_EN at RB4_bit;
sbit LCD_D4 at RB3_bit;
sbit LCD_D5 at RB2_bit;
sbit LCD_D6 at RB1_bit;
sbit LCD_D7 at RB0_bit;              //Fine configurazione LCD

sbit LCD_RS_Direction at TRISB5_bit; //Pin uscita LCD
sbit LCD_EN_Direction at TRISB4_bit;
sbit LCD_D4_Direction at TRISB3_bit;
sbit LCD_D5_Direction at TRISB2_bit;
sbit LCD_D6_Direction at TRISB1_bit;
sbit LCD_D7_Direction at TRISB0_bit;


unsigned int Temp;                   //Variabile temperatura
unsigned short DuCy, Vel;            //Variabile duty cycle e variabile velocit
char txt0[7];                        //Testo temperatura
char txt1[7];                        //Testo velocit

void main() {                        //Programma principale

  TRISC = 0;                         //PORTC uscite
  PWM1_Init(6250);                   //Frequenza PWM 6.25KHz
  PWM1_Set_Duty(0);                  //PWM spento
  PWM1_Start();                      //PWM start

  ADC_Init();                        //ADC inizializzato
  Lcd_Init();                        //Initializza LCD
  Lcd_Cmd(_LCD_CLEAR);               //Pulisci display
  Lcd_Cmd(_LCD_CURSOR_OFF);          //Disattiva cursore

  while(1){                          //Ciclo infinito
    Temp = ADC_Read(1);              //Leggi valore ADC
    Temp = Temp * 0.48828;           //Converti in gradi centigradi

    if(Temp < 30){                   //Se la Temp  minore di trenta...
      DuCy = 0;                      //Duty Cycle
      PWM1_Set_Duty(DuCy);           //Ventola spenta
    }

    else if(Temp > 80){              //Se la Temp  maggiore di ottanta...
      DuCy = 255;                    //Duty cycle 100%
      PWM1_Set_Duty(DuCy);           //Ventola accesa al massimo
    }

    else{                            //Se Temp  nel range 30-80 gradi allora...
      DuCy = Temp * 3.18;            //Moltiplica Temp per 255/TempMax (255/80=3.18)
      PWM1_Set_Duty(DuCy);           //Imposta il duty cycle calcolato
    }

    Delay_ms(500);                   //0.5S prima di ricontrollare la Temp

    Lcd_Cmd(_LCD_CLEAR);             //Pulisci LCD
    Lcd_Cmd(_LCD_FIRST_ROW);         //Vai alla prima riga
    Lcd_Out_Cp(" Temp  ");           //Scrivi temperatura
    IntToStrWithZeros(Temp, txt0);   //Converti in stringa
    Lcd_Out_Cp(txt0);                //Scrivi la temperatura
    Lcd_Out_Cp("^C   ");             //Scrivi gradi centigradi
    
    Lcd_Cmd(_LCD_SECOND_ROW);        //Vai alla seconda riga
    Lcd_Out_Cp(" Vel   ");           //Scrivi Vel
    DuCy = DuCy/2.55;                //Calcola percentuale
    IntToStrWithZeros(DuCy, txt1);   //Converti in stringa
    Lcd_Out_Cp(txt1);                //Scrivi la velocit
    Lcd_Out_Cp("%");                 //Scrivi %
  }//fine ciclo infinito
}//fine programma